---
title: WebAssembly.compile()
slug: Web/JavaScript/Reference/Global_Objects/WebAssembly/compile
tags:
  - API
  - JavaScript
  - Method
  - Object
  - Reference
  - WebAssembly
  - compile
---
<div>{{JSRef}}</div>

<p>The <strong><code>WebAssembly.compile()</code></strong> function compiles WebAssembly binary code into a {{jsxref("WebAssembly.Module")}} object. This function is useful if it is necessary to a compile a module before it can be instantiated (otherwise, the {{jsxref("WebAssembly.instantiate()")}} function should be used).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Promise&lt;WebAssembly.Module&gt; WebAssembly.compile(bufferSource);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>bufferSource</em></dt>
 <dd>A <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed array</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a> containing the binary code of the .wasm module you want to compile.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A <code>Promise</code> that resolves to a {{jsxref("WebAssembly.Module")}} object representing the compiled module.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>If <code>bufferSource</code> is not a <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed array</a>, a {{jsxref("TypeError")}} is thrown.</li>
 <li>If compilation fails, the promise rejects with a {{jsxref("WebAssembly.CompileError")}}.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Using_compile">Using compile</h3>

<p>The following example compiles the loaded simple.wasm byte code using the <code>compile()</code> function and then sends it to a <a href="/en-US/docs/Web/API/Web_Workers_API">worker</a> using <a href="/en-US/docs/Web/API/Worker/postMessage">postMessage()</a>.</p>

<pre class="brush: js">var worker = new Worker("wasm_worker.js");

fetch('simple.wasm').then(response =&gt;
  response.arrayBuffer()
).then(bytes =&gt;
  WebAssembly.compile(bytes)
).then(mod =&gt;
  worker.postMessage(mod)
);</pre>

<div class="note">
<p><strong>Note</strong>: You'll probably want to use {{jsxref("WebAssembly.compileStreaming()")}} in most cases, as it is more efficient than <code>compile()</code>.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAssembly JS', '#dom-webassembly-compile', 'compile()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.WebAssembly.compile")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/WebAssembly">WebAssembly</a> overview page</li>
 <li><a href="/en-US/docs/WebAssembly/Concepts">WebAssembly concepts</a></li>
 <li><a href="/en-US/docs/WebAssembly/Using_the_JavaScript_API">Using the WebAssembly JavaScript API</a></li>
</ul>
